#pragma once

#include "imgui.h"
#include <GL/glew.h>
#include <GLFW/glfw3.h>
#include "../data/state.h"

namespace UI {
    enum class Actions {
        None = 0,
        FPS = 1 << 0,
        FullScreen = 1 << 1,
        ClearColor = 1 << 2
    };
    inline Actions operator|(Actions a, Actions b) {
        return static_cast<Actions>(static_cast<int>(a) | static_cast<int>(b));
    }
    inline bool operator&&(Actions a, Actions b) {
        return static_cast<int>(a) & static_cast<int>(b);
    }

    void setup(GLFWwindow*);
    void unload();
    Actions draw(options&, state&, const reports&, GLuint aim);

    bool isFocus();
    void render();
};
