#pragma once

#include <GL/glew.h>
#include <sys/types.h>

class PassParams;

/// Abstract OpenGL Buffer
class Buffer {
public:
    Buffer(GLenum shape);
    virtual ~Buffer();

    struct params {
        bool vertexOnly;
    };

    virtual uint draw(params params) = 0;

protected:
    GLenum Shape;

    GLuint VertexBufferID;

    void enableVertexAttrib();
    void disableVertexAttrib();
    void enableAllAttribs();
    void disableAllAttribs();

    void setVertices(const unsigned long size, const void *data);
};
