#pragma once

#include <GL/glew.h>
#include <string>
#include <vector>

#include "Shader.hpp"

/// OpenGL shaders pipeline
class Program {
public:
    virtual ~Program();

    void useIt();
    virtual std::string getName() const = 0;

    static GLuint loadTexture(const std::string &name, bool linear = true);
    static GLuint loadRawTexture(const std::string &name);
    static GLuint loadTextureArray(const std::vector<std::string> &names, const std::string &suffix = "");

protected:
    void load(const std::vector<Shader *> &shaders);
    virtual Shader *loadShader(GLenum type, const std::vector<std::string> &flags = {});
    GLuint ProgramID;
};
