#include "SimpleProgram.hpp"

SimpleProgram::SimpleProgram() : Program() {

    std::vector<std::string> flags;
    std::vector<Shader*> shaders;
    shaders.push_back(loadShader(GL_VERTEX_SHADER, flags));
    shaders.push_back(loadShader(GL_FRAGMENT_SHADER, flags));
    load(shaders);

    MVPMatrixID = glGetUniformLocation(ProgramID, "MVP");
}

SimpleProgram::~SimpleProgram() { }

std::string SimpleProgram::getName() const {
    return "Simple";
}

void SimpleProgram::setMVP(const GLfloat *matrix) {
    glUniformMatrix4fv(MVPMatrixID, 1, GL_FALSE, matrix);
}